ArrayList<Candle>candles = new ArrayList<Candle>();
ArrayList<Say>says = new ArrayList<Say>();
void setup(){
   //smooth();
   size(250,250); 
   textSize(20);
  candles.add(new Candle(50,25));   
  candles.add(new Candle(100,35));   
  candles.add(new Candle(150,35));   
  candles.add(new Candle(175,25));   
}

void draw(){
  background(200);
  stroke(240,160,160);
  fill(255);
  strokeWeight(4);

  ellipse(125,200,200,50);
  
  ellipse(125,150,200,50);


  noStroke();
  rect(25,100,200,100);
  stroke(240,160,160);
  
  line(25,100,25,200);  
  line(225,100,225,200);  
  ellipse(125,100,200,50);
  boolean allOut = true;
  for(Candle c : candles){
     c.draw(); 
     if(mousePressed){
        if(c.hit()){
           c.lit = false;
        } 
     }
     if(c.lit) allOut = false;
  }
  if(allOut){
     says.add(new Say()); 
  }
  for(Say s : says){
     s.draw(); 
  }
}

class Say{
  float x,y;
  color c;
   Say(){
      x = random(150);
      y = random(250);
      c = color(random(255),random(255),random(255));
   } 
  void draw(){
    stroke(c);
    fill(c);
     text("HAPPY BIRTHDAY GT!!!",x,y);
  } 
}

class Candle{
  float x,y;
  boolean lit = true;
  Candle(float px, float py){
     x = px;
    y = py; 
  }
  void draw(){
     noStroke();
    fill(255,0,0);
     rect(x,y,10,80); 
     
     strokeWeight(1);
     stroke(0);
     line(x + 5, y, x + 5, y - 5);
     

      
     if(lit){
     fill(255,255,0);
noStroke();     
       pushMatrix();
       translate(x+5,y-5);
         triangle(0,0,random(-R1),random(-R2),random(-R1),random(-R2)   );
         popMatrix();
     }
     
     
     
  }
  boolean hit(){
     if(dist(x+5,y-5,mouseX,mouseY) < 10){
        return true;
     } 
     return false;
  }
}

float R1 = 8;
float R2 = 20;
